#include <queue>
#include <cstdio>
#include <algorithm>
using namespace std;

const int MAXN = 1 << 5;
const int MAXPOS = 1 << 21;
const int MAXK = 1 << 4;

const int dx[] = { -1 , 0 , 0 , 1 };
const int dy[] = { 0 , -1 , 1 , 0 };

const int st[] = { 20 , 20 * 20 , 20 * 20 * 3 };

struct key {
    int x , y;
    int f;
    
    char q[MAXK];
    int w[MAXK];
};

int n , m;
char s[MAXN][MAXN];
int a[MAXN][MAXN];
key k[MAXK];
int r , f;

int sx , sy;
int mask;
int ex , ey;

int used[MAXPOS];
int prev[MAXPOS];
queue < int > qu;

void read() {
    int i , j;
    char c;
    
    scanf ("%d%d",&n,&m);
    for (i=1;i<=n;i++) {
        scanf ("%s",s[i] + 1);
        for (j=1;j<=m;j++) {
            if ( s[i][j] == 'K' ) {
                a[i][j] = ++ r;
                k[r].x = i;
                k[r].y = j;
            }
            
            if ( isdigit ( s[i][j] ) ) {
                ++ f;
                a[i][j] = s[i][j] - '0';
            }
            
            if ( s[i][j] == 'S' ) {
                sx = i;
                sy = j;
            }
            
            if ( s[i][j] == 'E' ) {
                ex = i;
                ey = j; 
            }
        }
    }
    
    scanf ("%c",&c);    
    for (i=1;i<=r;i++) {
        k[i].f = 0;
        while ( scanf ("%c",&c) , c != '\n' ) {
            if ( c == ' ' ) continue;
            
            ++ k[i].f;
            k[i].q[ k[i].f ] = c;
            
            scanf ("%c",&c);
            k[i].w[ k[i].f ] = c - '0';
        }
    }
    
    for (i=0;i<f;i++) {
        scanf ("%c",&c);
        mask |= ((c - '0') << i);
    }
}

int code ( int x , int y , int t , int mask ) {
    -- x; -- y;
    return x + y * st[0] + t * st[1] + mask * st[2];
}

void decode ( int &x , int &y , int &t , int &mask , int c ) {
    mask = c / st[2];   c %= st[2];
    t = c / st[1];      c %= st[1];
    y = c / st[0];      c %= st[0];
    x = c;

    ++ x; ++ y;
}

/*
0 - izpraveno
1 - nadqsno
2 - nadolu
*/

int check ( int x , int y , int mask ) {
    if ( x < 1 || y < 1 || x > n || y > m ) return 1;
    if ( s[x][y] == '_' ) return 1;
    if ( isdigit ( s[x][y] ) && ((mask ^ (1 << a[x][y])) & (1 << a[x][y])) ) return 1;
    
    return 0;
}

void make_key ( int x , int y , int &nmask ) {
    if ( s[x][y] == 'K' ) {
        int i;
        int idx = a[x][y];
        
        for (i=1;i<=k[idx].f;i++) {
            if ( k[idx].q[i] == 'O' )
                nmask |= (1 << k[idx].w[i]);
            if ( k[idx].q[i] == 'C' )
                nmask &= ~(1 << k[idx].w[i]);
            if ( k[idx].q[i] == 'T' )
                nmask ^= (1 << k[idx].w[i]);
        }
    }
}

void print ( int x ) {
    if ( prev[x] == -1 ) return ;
    print ( prev[x] );
    
    int q1 , q2 , q3 , q4;
    int w1 , w2 , w3 , w4;
    
    decode ( q1 , q2 , q3 , q4 , x );
    decode ( w1 , w2 , w3 , w4 , prev[x] );
    
    if ( w1 < q1 ) printf ("d");
    if ( w1 > q1 ) printf ("u");
    if ( q2 < w2 ) printf ("l");
    if ( q2 > w2 ) printf ("r");
}

void solve() {
    int i;
    int x , y , t;
    int q , w , e , nmask;
    int ans = 0;
    
    x = code ( sx , sy , 0 , mask );
    
    used[x] = 1;
    prev[x] = -1;
    qu.push ( x );
    
    while ( !qu.empty() ) {
        x = y = qu.front();
        qu.pop();
        
        decode ( sx , sy , t , mask , x );
        
        if ( sx == ex && sy == ey && !t ) {
            ans = used[y] - 1;
            break;
        }
        
        for (i=0;i<4;i++) {
            if ( t ) {
                q = sx + dx[i];
                w = sy + dy[i];
                
                if ( (t == 2 && (i == 0 || i == 3)) || (t == 1 && (i == 1 || i == 2)) ) {
                    e = 0;
                    if ( i == 2 ) ++ w;
                    if ( i == 3 ) ++ q;
                }
                else
                    e = t;
            } else {
                q = sx + dx[i];
                w = sy + dy[i];
                
                if ( i == 0 ) -- q;
                if ( i == 1 ) -- w;
                
                if ( i == 0 || i == 3 ) e = 2;
                else e = 1;
            }
            nmask = mask;
            
            if ( e == 0 && ( check ( q , w , nmask ) || s[q][w] == '^' ) ) continue;
            if ( e == 1 && ( check ( q , w , nmask ) || check ( q , w + 1 , nmask )) ) continue;
            if ( e == 2 && ( check ( q , w , nmask ) || check ( q + 1 , w , nmask )) ) continue;
            
            if ( e == 0 ) make_key ( q , w , nmask );
            if ( e == 1 ) {
                make_key ( q , w , nmask );
                make_key ( q , w + 1 , nmask );
            }
            if ( e == 2 ) {
                make_key ( q , w , nmask );
                make_key ( q + 1 , w , nmask );
            }
            
            if ( e == 0 && check ( q , w , nmask ) ) continue;
            if ( e == 1 && ( check ( q , w , nmask ) || check ( q , w + 1 , nmask )) ) continue;
            if ( e == 2 && ( check ( q , w , nmask ) || check ( q + 1 , w , nmask )) ) continue;
            
            x = code ( q , w , e , nmask );
            if ( !used[x] ) {
                qu.push ( x );
                used[x] = used[y] + 1;
                prev[x] = y;
            }
        }
    }
    
    printf ("%d\n",ans);
    if ( ans ) {
        print ( x );
        printf ("\n");
    }
}

int main() {
    read();
    solve();
    
    return 0;
}
