
#include <vector>
#include <iostream>
#include <sstream>
#include <cassert>
using namespace std;

#define DEBUG(x) cout << #x << ": " << x << endl;

char *dir = "udlr";
int new_s[][4] = {{1, 1, 2, 2},  {0, 0, 1, 1},  {2, 2, 0, 0}};
int dx[][4] =    {{-2, 1, 0, 0}, {-1, 2, 0, 0}, {-1, 1, 0, 0}};
int dy[][4] =    {{0, 0, -2, 1}, {0, 0, -1, 1}, {0, 0, -1, 2}};

int ox[3] = {0, 1, 0};
int oy[3] = {0, 0, 1};

struct Key {
    char id;
    char state;
};

int n, m, k = 0, d = 0;
int id[32][32];
char g[32][32];
char buf[1024];
char by[1228800];
int prev[1228800];
int queue[1228800];
vector <Key> key[1024];

inline int encode(int x, int y, int s, int m) {
    return (((x * 20) + y) * 3 + s) * 1024 + m;
}
inline void decode(int c, int& x, int& y, int& s, int& m) {
    m = c % 1024; c /= 1024;
    s = c %    3; c /=    3;
    y = c %   20; c /=   20;
    x = c %   20;
}

void input() {
    memset(id, -1, sizeof(id));
    scanf("%d %d\n", &n, &m);
    for (int i = 0; i < n; ++i)
        gets(g[i]);
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j)
            if (g[i][j] == 'K') {
                id[i][j] = k;
                gets(buf);
                stringstream ss;
                ss << buf;
                //cout << k << " " << buf << endl;
                int z = 0;
                while (ss >> buf)
                    key[k].push_back((Key) {buf[1], buf[0]});
                ++k;
            }
            else if (g[i][j] >= '0' && g[i][j] <= '9') {
                ++d;
            }
    gets(buf);   
}
inline bool inside(int i, int j) {
    return i >= 0 && i < n && j >= 0 && j < m;
}
void bfs() {
    int x = -1, y = -1, s = 0, m;
    int nx, ny, ns, nm;
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j)
            if (g[i][j] == 'S') {
                x = i;
                y = j;
                goto ready;
            }
    ready: ;
    m = 0;
    for (int i = 0; buf[i]; ++i) {
        if (buf[i] == '1')
            m |= (1 << i);
    }
    memset(prev, -1, sizeof(prev));
    memset(by, -1, sizeof(by));
    int begin = encode(x, y, s, m), end = -1;
    int p3 = 0;
    queue[p3] = begin;
    ++p3;
    prev[begin] = -2;
    int crnt;
    int xx[2];
    int yy[2];
    int num, nxt;
    for (int i = 0; i < p3; ++i) {
        decode(queue[i], x, y, s, m);
        if (g[x][y] == 'E' && s == 0) {
            end = queue[i];
            break;
        }
        crnt = queue[i];
        for (int j = 0; j < 4; ++j) {
            nx = x + dx[s][j];
            ny = y + dy[s][j];
            ns = new_s[s][j];
            nm = m;
            xx[0] = nx;
            yy[0] = ny;
            xx[1] = xx[0] + ox[s];
            yy[1] = yy[0] + oy[s];
            bool ok = true;
            for (int p = 0; p < (ns == 0 ? 1 : 2); ++p) {
                if (!inside(xx[p], yy[p])) {
                    ok = false;
                    break;
                }
                if (g[xx[p]][yy[p]] == '_')
                    ok = false;
                if (ns == 0 && g[xx[p]][yy[p]] == '^')
                    ok = false;
                if (g[xx[p]][yy[p]] >= '0' && g[xx[p]][yy[p]] <= '9')
                    if ((m & (1 << (g[xx[p]][yy[p]] - '0'))) == 0)
                        ok = false;
                if (g[xx[p]][yy[p]] == 'K') {
                    num = id[xx[p]][yy[p]];
                    for (int z = 0; z < key[num].size(); ++z) {
                        switch (key[num][z].state) {
                            case 'O':
                                nm |= (1 << (key[num][z].id - '0'));
                                break;
                            case 'C':
                                nm &= ~(1 << (key[num][z].id - '0'));
                                break;
                            case 'T':
                                nm ^= (1 << (key[num][z].id - '0'));
                                break;
                        }
                    }
                }
            }
            if (!ok)
                continue;
            nxt = encode(nx, ny, ns, nm);
            if (prev[nxt] == -1) {
                prev[nxt] = queue[i];
                by[nxt] = j;
                queue[p3++] = nxt;
            }
        }
    }
    string res = "";
    if (end == -1) {
        cout << 0 << endl;
    } else {
        string res;
        int cur = end;
        while (by[cur] != -1) {
            res += dir[by[cur]];
            cur = prev[cur];
        }
        reverse(res.begin(), res.end());
        cout << res.size() << endl;
        cout << res << endl;
    }
}
int main() {
    input();
    bfs();
    return 0;
}
