#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <cmath>

using namespace std;

#define f(i, n) for(int i = 0; i < (n); i ++)
#define ff(i, st, end) for(int i = (st); i < (end); i ++)
#define fv(i, v) for(int i = 0; i < int((v).size()); i ++)
#define fx(i, v) for(typeof( (v).begin() ) it = (v).begin(); it != (v).end(); it ++)
#define all(v) (v).begin(), (v).end()

#define ABS(x) ( (x) < 0 ? -(x) : (x) )

struct point
{
	long long x,y;
	point(long long _x, long long _y) {x = _x; y = _y;};
	point() {};
};

point operator-(const point &a, const point &b)
{
	return point( a.x - b.x, a.y - b.y );
}

struct pointD
{
	double x, y;
	pointD() {};
	pointD( const point &p ){ x = (double)p.x; y = (double)p.y; }
	pointD(double _x, double _y){ x = _x; y = _y; }
};

double cp(pointD a, pointD b, pointD c)
{
	return (b.x - a.x) * (c.y - a.y) - (c.x - a.x) * (b.y - a.y);
}

bool use[1000005];
double area(pointD a[], int n)
{
	a[n] = a[0];
	double ans = 0;
	f(i, n)	ans += a[i].x * a[i + 1].y - a[i].y * a[i + 1].x;
	return ans;
}

double dist(pointD a, pointD b)
{
	return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
}

pointD comp;
bool cmp(pointD a, pointD b)
{
	double cp1 = cp( comp, a, b );
	if( fabs(cp1) > 1e-7 )	return (cp1 > 1e-9);
	return dist(comp,a) < dist(comp,b);
}

point a[1005], b[1005];
int topA, topB, p, q, topR;
long long Sa, Sb;
pointD res[1000005];

long long cp(point a, point b, point c)
{
	return (b.x - a.x) * (c.y - a.y) - (c.x - a.x) * (b.y - a.y);
}

long long area(point a[], int n)
{
	a[n] = a[0];
	long long ans = 0;
	f(i, n)	ans += a[i].x * a[i + 1].y - a[i].y * a[i + 1].x;
	return ans;
}

bool inB(point p)
{
	long long P = 0;
	f(i, topB) P += ABS( cp( p, b[i], b[i + 1] ) );
	if( P == Sb )	return 1;
	return 0;
}

bool intersect( point a, point b, point c, point d )
{
	long long cp1 = cp( a, b, d ), cp2 = cp( a, b, c );
//	cout << cp1 << " " << cp2 << "\n";
	if( cp1 * cp2 > 0 )	return 0;
	long long cp3 = cp( c, d, a ), cp4 = cp( c, d, b );
//	cout << cp3 << " " << cp4 << "\n";
	if( cp3 * cp4 > 0 )	return 0;
	return 1;
}

bool intersect( point a, point b, point c, point d, pointD &res )
{
	long long cp1 = cp( a, b, d ), cp2 = cp( a, b, c );
	if( cp1 * cp2 > 0 )	return 0;
	long long cp3 = cp( c, d, a ), cp4 = cp( c, d, b );
	if( cp3 * cp4 > 0 )	return 0;
	long long all = ABS(cp3) + ABS(cp4);
	double coef = ABS(cp3)/double(all);
	point vec = b - a;
	res.x = a.x + coef * vec.x;
	res.y = a.y + coef * vec.y;
	return 1;
}


bool used[1001];
bool inA(point p)
{
//	cout << p.x << " " << p.y << "\n";
	memset(used,0,sizeof(used));
	f(i, topA)
	{
		long long dx = a[i].x - p.x;
		long long dy = a[i].y - p.y;
		if( dx == 0 )	used[1000] = 1;
		else			used[ (1000*dy)/dx ] = 1;
	}
	int tan = 0;
	for(; used[tan]; tan ++ );
//	cout << tan << "\n";
	
	point to( p.x + 1000000, p.y + 1000 * tan );
//	cout << to.x << " " << to.y << "\n";
	
	int cnt = 0;
	f(i, topA)
		if( intersect( p, to, a[i], a[i + 1] ) )
			cnt ++;
//	cout << (cnt & 1) << " res\n";
	return cnt & 1;
}


// COMPILE WITH -O3 !!!!!!!!!!!!!!!!!!!!!!!!!

int main()
{	
	while(1)
	{
		cin >> a[topA].x >> a[topA].y;
		topA ++;
		cin.get();
		if(cin.get() == '\n')	break;
		cin.unget();
	}
	while( cin >> p >> q)
		b[topB ++] = point(p,q);
	b[topB] = b[0]; Sb = area(b, topB);
	a[topA] = a[0]; Sa = area(a, topA);
//	cout << area(a, topA) << "\n";
//	cout << area(b, topB) << "\n";
/*	cout << inB( point(5,5) ) << "\n";
	cout << inB( point(2,3) ) << "\n";
	cout << inB( point(15,5) ) << "\n";
	cout << inB( point(10,10) ) << "\n"; */
//	cout << inA( point( 0,0 ) );
	f(i, topA)	if( inB( a[i] ) )	res[ topR ++ ] = a[i];
	f(i, topB)	if( inA( b[i] ) )	res[ topR ++ ] = b[i];
	
	pointD p;
	f(i, topA) f(j, topB)
		if( intersect( a[i], a[i + 1], b[j], b[j + 1], p ) )
			res[ topR ++ ] = p;
	if( topR == 0 )
	{
		printf("0\n");
		return 0;
	}
	
	
//	f(i, topR)	cout << res[i].x << " " << res[i].y << "\n";
	
	// 	ADD POINT(5,5) TO A AND REMOVE DUPLICATES !!!!!!!!!!!!!!!! (OK, maybe not needed...)
	
	pointD mn(1e20, 1e20);
	int ind = 0;
	f(i, topR)
		if( (res[i].y < mn.y) || ( (res[i].y == mn.y) && (res[i].x < mn.x) ) )
		{
			mn.x = res[i].x; mn.y = res[i].y;
			ind = i;
		}
	swap( res[0], res[ind] );
	comp = res[0];
	sort(res + 1, res + topR, cmp);
//	cout << "\n";
//	f(i, topR)	cout << res[i].x << " " << res[i].y << "\n";
//	f(i, topR - 1)
//		if( ( (res[i].x - res[i + 1].x ) )
	
	printf("%.2lf\n", area(res, topR) * .5);
//	cout << area(res, topR) * .5 << "\n";

/*	intersect( b[0], b[1], a[1], a[2] );
	cout << cp( b[0], b[1], a[2] ) << " " << cp( b[0], b[1], a[1] ) << "\n";
	cout << b[0].x << " " << b[0].y << "\n";
	cout << b[1].x << " " << b[1].y << "\n";
	cout << a[2].x << " " << a[2].y << "\n"; */
//	printf("%lf\n", clock() / double(CLOCKS_PER_SEC));
    return 0;
}
